Rice.require 'devmode_to_printticket'
Rice.require 'printticket_to_devmode'
Rice.require 'get_printcapabilities'
Rice.require 'validate_printticket'
Rice.require 'printticket_core'

--------------------------------------------------------------------------------
--	Function Name	:	devmode_to_printticket
-- 	Return 			: 	Success : PrintTicket
--						Failure : nil
--------------------------------------------------------------------------------
function devmode_to_printticket( architecture_type )
	local result = act_devmode_to_printticket( architecture_type )
	return result
end

--------------------------------------------------------------------------------
--	Function Name	:	printticket_to_devmode
-- 	Return 			: 	Success : "true"
--						Failure : "false"
--------------------------------------------------------------------------------
function printticket_to_devmode( architecture_type )
	local result = act_printticket_to_devmode( architecture_type )
	return result
end

--------------------------------------------------------------------------------
--	Function Name	:	get_print_capabilities
-- 	Return 			: 	Success : PrintCapabilites
--						Failure : nil
--------------------------------------------------------------------------------
function get_print_capabilities( architecture_type )
	local result = act_get_print_capabilities( architecture_type )
	return result
end

--------------------------------------------------------------------------------
--	Function Name	:	validate_printticket
-- 	Return 			: 	Success : PrintTicket
--						Failure : nil
--------------------------------------------------------------------------------
function validate_printticket( architecture_type )
	local result = act_validate_printticket( architecture_type )
	return result
end

return true
