Rice.require 'Rice.CapsDB'
Rice.require 'Rice.PrintTicket'
Rice.require 'printticket_core'
Rice.require 'devmode_to_printticket'
Rice.require 'printticket_to_devmode'
Rice.require 'printticket_to_devmode_table'

function act_validate_printticket( architecture_type )
	local result = 'false'
	local cdb = Rice.CapsDB
	local pt = Rice.PrintTicket
	
	--file = io.open( 'C:\\temp\\act_validate_printticket.txt', 'w' )
	--pt.save_xml('C:\\temp\\in_in_PT.xml')
	--if( file ) then

		if pt and cdb and architecture_type and set_namespace(pt) then
			--file:write('in_if\r\n')
			-- get items from default devmode
			local pre_all_item_tbl = get_all_items(cdb)
			--file:write('get_all_items\r\n')

			-- get items from print ticket
			local converted_xpath_table 	= generate_all_target_xpath(pt)
			--file:write('generate_all_target_xpath\r\n')
			local extracted_values 			= extract_value(pt,converted_xpath_table)
			--file:write('extract_value\r\n')
			local item_table_from_pt 		= convert_item_values(extracted_values)
			--file:write('convert_item_values\r\n')

			-- overwrite pre_all_item_tbl using item_table_from_pt
			for i in pairs(pre_all_item_tbl) do
				for j in pairs(item_table_from_pt) do
					if(i == j) then
						pre_all_item_tbl[i]=item_table_from_pt[j]
					end
				end
			end
			--file:write('overwrite_pre_all_item_tbl\r\n')
			
			--pt.save_xml('C:\\temp\\in_PT.xml')

			act_printticket_to_devmode(architecture_type)
			--file:write('act_printticket_to_devmode\r\n')
--[[
			-- clear print ticket
			pt.delete_node('/'..solve_local_prefix(pt, 'psf:PrintTicket'))
			file:write('delete_node\r\n')

			act_devmode_to_printticket(architecture_type)
			file:write('act_devmode_to_printticket\r\n')
			
			--]]
			--pt.save_xml('C:\\temp\\out_PT.xml')

			-- get items from validated devmode
			local post_all_item_tbl = get_all_items(cdb)
			--file:write('get_all_items\r\n')

			-- compare pre_all_item_tbl with post_all_item_tbl
			local is_same_table = true
			for i in pairs(pre_all_item_tbl) do
				local is_same_key_value = false
				for j in pairs(post_all_item_tbl) do
					if(i == j) then
						if(pre_all_item_tbl[i]==post_all_item_tbl[j]) then
							is_same_key_value = true
						end
					end
				end
				if(false == is_same_key_value) then
					is_same_table = false
					break
				end
			end
			--file:write('compare_pre_all_item_tbl\r\n')

			if(true == is_same_table) then
				result = 'no_conflict'
				--file:write('no_conflict\r\n')
			else
				result = 'conflict_resolved'
				--file:write('conflict_resolved\r\n')
			end
		end
		
		--file:close()
	--end

	return result
end
