
function string:split(sep)

  if(type(self) ~= 'string') then
    error("bad argument #1 to 'split' (string expected, got " .. type(self) .. ")", 2)
  end

  if(type(sep) ~= 'string') then
    error("bad argument #2 to 'split' (string expected, got " .. type(sep) .. ")", 2)
  end  
  
  local ret = {}
  local pos = 1
  while(self:len() >= pos) do
    local head, tail = self:find(sep, pos)
    if(head) then
      table.insert(ret, self:sub(pos, head - 1))
      pos = tail + 1
    else
      table.insert(ret, self:sub(pos))
      break
    end
  end
  return ret
end

return true
