Rice.require 'Native'
Rice.require 'UTF8'
Rice.require 'Rice.CapsDB'

local portname = Rice.CapsDB.get('wimportname')

if(portname) then
  portname = UTF8.decode(portname)
  local url = portname:find('[^%da-fA-F:]') and
  'http://' .. portname         or -- Not IPv6
  'http://[' .. portname .. ']'    -- IPv6
  
  Native.Dll('shell32.dll') 
  :api('ShellExecute')
  :with_ptr(Native.null_ptr()) -- hwnd
  :with_string('open')        -- lpVerb
  :with_string(url)           -- lpFile
  :with_ptr(Native.null_ptr()) -- lpParameters
  :with_ptr(Native.null_ptr()) -- lpDirectory
  :with_int(1)                -- nShowCmd (SW_SHOWNORMAL)
  :call_ptr()                 -- return HINSTANCE
end

return true
